Index: /trunk/src/sys/arch/arc/arc/p_sni_rm200pci.c
===================================================================
--- /trunk/src/sys/arch/arc/arc/p_sni_rm200pci.c	(revision 151)
+++ /trunk/src/sys/arch/arc/arc/p_sni_rm200pci.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: p_sni_rm200pci.c,v 1.12 2007/12/03 15:33:14 ad Exp $	*/
+/*	$NetBSD: p_sni_rm200pci.c,v 1.12.36.1 2010/12/29 01:44:21 matt Exp $	*/
 /*	$OpenBSD: machdep.c,v 1.36 1999/05/22 21:22:19 weingart Exp $	*/
 
@@ -76,10 +76,13 @@
  */
 
+#define __INTR_PRIVATE
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: p_sni_rm200pci.c,v 1.12 2007/12/03 15:33:14 ad Exp $");
+__KERNEL_RCSID(0, "$NetBSD: p_sni_rm200pci.c,v 1.12.36.1 2010/12/29 01:44:21 matt Exp $");
 
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/device.h>
+#include <sys/intr.h>
+
 #include <uvm/uvm_extern.h>
 
@@ -122,26 +125,14 @@
  */
 /* XXX lack of hardware info for sni_rm200pci */
-static const uint32_t sni_rm200pci_ipl_sr_bits[_IPL_N] = {
+static const struct ipl_sr_map sni_rm200pci_ipl_sr_map = {
+    .sr_bits = {
 	[IPL_NONE] = 0,
-	[IPL_SOFTCLOCK] =
-	    MIPS_SOFT_INT_MASK_0,
-	[IPL_SOFTNET] =
-	    MIPS_SOFT_INT_MASK_0 | MIPS_SOFT_INT_MASK_1,
-	[IPL_VM] =	/* XXX */
-	    MIPS_SOFT_INT_MASK_0 | MIPS_SOFT_INT_MASK_1 |
-	    MIPS_INT_MASK_0 |
-	    MIPS_INT_MASK_1 |
-	    MIPS_INT_MASK_2 |
-	    MIPS_INT_MASK_3 |
-	    MIPS_INT_MASK_4 |
-	    MIPS_INT_MASK_5,
-	[IPL_SCHED] =	/* XXX */
-	    MIPS_SOFT_INT_MASK_0 | MIPS_SOFT_INT_MASK_1 |
-	    MIPS_INT_MASK_0 |
-	    MIPS_INT_MASK_1 |
-	    MIPS_INT_MASK_2 |
-	    MIPS_INT_MASK_3 |
-	    MIPS_INT_MASK_4 |
-	    MIPS_INT_MASK_5,
+	[IPL_SOFTCLOCK] =	MIPS_SOFT_INT_MASK_0,
+	[IPL_SOFTNET] =		MIPS_SOFT_INT_MASK,
+	[IPL_VM] =		MIPS_INT_MASK, 	/* XXX */
+	[IPL_SCHED] =		MIPS_INT_MASK,
+	[IPL_DDB] =		MIPS_INT_MASK,
+	[IPL_HIGH] =		MIPS_INT_MASK,
+    },
 };
 
@@ -160,5 +151,5 @@
 	 * Initialize interrupt priority
 	 */
-	ipl_sr_bits = sni_rm200pci_ipl_sr_bits;
+	ipl_sr_map = sni_rm200pci_ipl_sr_map;
 
 	/*
Index: /trunk/src/sys/arch/arc/include/intr.h
===================================================================
--- /trunk/src/sys/arch/arc/include/intr.h	(revision 151)
+++ /trunk/src/sys/arch/arc/include/intr.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: intr.h,v 1.22.18.1 2010/02/06 02:57:43 matt Exp $	*/
+/*	$NetBSD: intr.h,v 1.22.18.2 2010/12/29 01:44:21 matt Exp $	*/
 
 /*-
@@ -33,59 +33,9 @@
 #define _ARC_INTR_H_
 
-#define IPL_NONE	0	/* disable only this interrupt */
-#define IPL_SOFTCLOCK	1	/* generic software interrupts (SI 0) */
-#define IPL_SOFTBIO	1	/* clock software interrupts (SI 0) */
-#define IPL_SOFTNET	2	/* network software interrupts (SI 1) */
-#define IPL_SOFTSERIAL	2	/* serial software interrupts (SI 1) */
-#define	IPL_VM		3
-#define IPL_SCHED	4
-#define IPL_HIGH	4
-
-#define _IPL_N		5
-
-#define _IPL_SI0_FIRST	IPL_SOFTCLOCK
-#define _IPL_SI0_LAST	IPL_SOFTBIO
-
-#define _IPL_SI1_FIRST	IPL_SOFTNET
-#define _IPL_SI1_LAST	IPL_SOFTSERIAL
-
-/* Interrupt sharing types. */
-#define IST_NONE	0	/* none */
-#define IST_PULSE	1	/* pulsed */
-#define IST_EDGE	2	/* edge-triggered */
-#define IST_LEVEL	3	/* level-triggered */
+#include <mips/intr.h>
 
 #ifdef _KERNEL
 #ifndef _LOCORE
 
-#include <mips/locore.h>
-
-extern const uint32_t *ipl_sr_bits;
-
-#define spl0()		(void)_spllower(0)
-#define splx(s)		(void)_splset(s)
-
-typedef int ipl_t;
-typedef struct {
-	ipl_t _sr;
-} ipl_cookie_t;
-
-static inline ipl_cookie_t
-makeiplcookie(ipl_t ipl)
-{
-
-	return (ipl_cookie_t){._sr = ipl_sr_bits[ipl]};
-}
-
-static inline int
-splraiseipl(ipl_cookie_t icookie)
-{
-
-	return _splraise(icookie._sr);
-}
-
-#include <sys/spl.h>
-
-struct clockframe;
 void arc_set_intr(uint32_t, uint32_t (*)(uint32_t, struct clockframe *), int);
 extern uint32_t cpu_int_mask;
Index: /trunk/src/sys/arch/atari/stand/tostools/file2swp/Makefile
===================================================================
--- /trunk/src/sys/arch/atari/stand/tostools/file2swp/Makefile	(revision 151)
+++ /trunk/src/sys/arch/atari/stand/tostools/file2swp/Makefile	(revision 152)
@@ -1,3 +1,3 @@
-#	$NetBSD: Makefile,v 1.1 2002/02/27 20:21:16 leo Exp $
+#	$NetBSD: Makefile,v 1.1.1.1 2002/02/27 20:21:16 leo Exp $
 
 PROG	= file2swp.ttp
Index: /trunk/src/sys/arch/cobalt/cobalt/bus.c
===================================================================
--- /trunk/src/sys/arch/cobalt/cobalt/bus.c	(revision 151)
+++ /trunk/src/sys/arch/cobalt/cobalt/bus.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: bus.c,v 1.35.16.3 2010/01/20 09:04:32 matt Exp $	*/
+/*	$NetBSD: bus.c,v 1.35.16.4 2010/12/24 07:50:58 matt Exp $	*/
 
 /*
@@ -32,5 +32,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: bus.c,v 1.35.16.3 2010/01/20 09:04:32 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: bus.c,v 1.35.16.4 2010/12/24 07:50:58 matt Exp $");
 
 #include <sys/param.h>
@@ -116,4 +116,13 @@
 	*nbshp = bsh + offset;
 	return 0;
+}
+
+paddr_t
+bus_space_mmap(bus_space_tag_t t, bus_addr_t addr, off_t off, int prot,
+    int flags)
+{
+
+	/* XXX not implemented */
+	return -1;
 }
 
Index: /trunk/src/sys/arch/cobalt/cobalt/machdep.c
===================================================================
--- /trunk/src/sys/arch/cobalt/cobalt/machdep.c	(revision 151)
+++ /trunk/src/sys/arch/cobalt/cobalt/machdep.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: machdep.c,v 1.98.10.4 2010/03/21 17:38:33 cliff Exp $	*/
+/*	$NetBSD: machdep.c,v 1.98.10.5 2010/12/24 07:52:01 matt Exp $	*/
 
 /*-
@@ -51,5 +51,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: machdep.c,v 1.98.10.4 2010/03/21 17:38:33 cliff Exp $");
+__KERNEL_RCSID(0, "$NetBSD: machdep.c,v 1.98.10.5 2010/12/24 07:52:01 matt Exp $");
 
 #include "opt_ddb.h"
@@ -189,4 +189,11 @@
 
 	}
+
+	/*
+	 * Copy exception-dispatch code down to exception vector.
+	 * Initialize locore-function vector.
+	 * Clear out the I and D caches.
+	 */
+	mips_vector_init(NULL);
 
 	/* Check for valid bootinfo passed from bootstrap */
@@ -258,11 +265,4 @@
 
 	/*
-	 * Copy exception-dispatch code down to exception vector.
-	 * Initialize locore-function vector.
-	 * Clear out the I and D caches.
-	 */
-	mips_vector_init(NULL);
-
-	/*
 	 * The boot command is passed in the top 512 bytes,
 	 * so don't clobber that.
Index: /trunk/src/sys/arch/cobalt/dev/panel.c
===================================================================
--- /trunk/src/sys/arch/cobalt/dev/panel.c	(revision 151)
+++ /trunk/src/sys/arch/cobalt/dev/panel.c	(revision 152)
@@ -1,3 +1,3 @@
-/* $NetBSD: panel.c,v 1.18 2008/05/09 10:59:55 tsutsui Exp $ */
+/* $NetBSD: panel.c,v 1.18.16.1 2010/12/29 08:18:05 matt Exp $ */
 
 /*
@@ -29,5 +29,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: panel.c,v 1.18 2008/05/09 10:59:55 tsutsui Exp $");
+__KERNEL_RCSID(0, "$NetBSD: panel.c,v 1.18.16.1 2010/12/29 08:18:05 matt Exp $");
 
 #include <sys/param.h>
@@ -42,4 +42,5 @@
 #include <sys/callout.h>
 #include <sys/select.h>
+#include <sys/reboot.h>
 
 #include <machine/bus.h>
@@ -77,12 +78,16 @@
 	"Starting up...  "
 };
-static const struct lcd_message shutdown_message = {
+static const struct lcd_message halt_message = {
 	"NetBSD/cobalt   ",
-	"Shutting down..."
+	"Halting...      "
+};
+static const struct lcd_message reboot_message = {
+	"NetBSD/cobalt   ",
+	"Rebooting...    "
 };
 
 static int	panel_match(device_t, cfdata_t, void *);
 static void	panel_attach(device_t, device_t, void *);
-static void	panel_shutdown(void *);
+static bool	panel_shutdown(device_t, int);
 
 static void	panel_soft(void *);
@@ -140,4 +145,6 @@
 	    1, &sc->sc_lcd.sc_iodr);
 
+	printf("\n");
+
 	sc->sc_lcd.sc_dev_ok = 1;
 	sc->sc_lcd.sc_cols = PANEL_COLS;
@@ -157,5 +164,5 @@
 	    HD_DDRAM_WRITE);
 
-	shutdownhook_establish(panel_shutdown, sc);
+	pmf_device_register1(self, NULL, NULL, panel_shutdown);
 
 	sc->sc_kp.sc_iot = maa->ma_iot;
@@ -170,12 +177,10 @@
 	callout_init(&sc->sc_callout, 0);
 	selinit(&sc->sc_selq);
-
-	printf("\n");
-}
-
-static void
-panel_shutdown(void *arg)
-{
-	struct panel_softc *sc = arg;
+}
+
+static bool
+panel_shutdown(device_t self, int howto)
+{
+	struct panel_softc *sc = device_private(self);
 	struct hd44780_io io;
 
@@ -183,7 +188,12 @@
 	io.dat = 0;
 	io.len = PANEL_VCOLS * PANEL_ROWS;
-	memcpy(io.buf, &shutdown_message, io.len);
+	if (howto & RB_HALT)
+		memcpy(io.buf, &halt_message, io.len);
+	else
+		memcpy(io.buf, &reboot_message, io.len);
 	hd44780_ddram_io(&sc->sc_lcd, sc->sc_lcd.sc_curchip, &io,
 	    HD_DDRAM_WRITE);
+
+	return true;
 }
 
Index: /trunk/src/sys/arch/cobalt/include/bus.h
===================================================================
--- /trunk/src/sys/arch/cobalt/include/bus.h	(revision 151)
+++ /trunk/src/sys/arch/cobalt/include/bus.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: bus.h,v 1.22 2008/04/28 20:23:16 martin Exp $	*/
+/*	$NetBSD: bus.h,v 1.22.18.1 2010/12/24 07:50:58 matt Exp $	*/
 
 /*
@@ -87,4 +87,14 @@
 int	bus_space_subregion(bus_space_tag_t t, bus_space_handle_t bsh,
 	    bus_size_t offset, bus_size_t size, bus_space_handle_t *nbshp);
+
+/*
+ *	paddr_t bus_space_mmap(bus_space_tag_t t,
+ *          bus_addr_t addr, off_t offset, int prot, int flags);
+ *
+ * Mmap bus space for a user application.
+ */
+
+paddr_t	bus_space_mmap(bus_space_tag_t t, bus_addr_t addr, off_t off, int prot,
+    int flags);
 
 /*
Index: /trunk/src/sys/arch/evbmips/adm5120/machdep.c
===================================================================
--- /trunk/src/sys/arch/evbmips/adm5120/machdep.c	(revision 151)
+++ /trunk/src/sys/arch/evbmips/adm5120/machdep.c	(revision 152)
@@ -1,3 +1,3 @@
-/* $NetBSD: machdep.c,v 1.6.10.5 2010/03/21 17:38:33 cliff Exp $ */
+/* machdep.c,v 1.6.10.5 2010/03/21 17:38:33 cliff Exp */
 
 /*-
@@ -108,5 +108,5 @@
 
 #include <sys/cdefs.h>			/* RCS ID & Copyright macro defns */
-__KERNEL_RCSID(0, "$NetBSD: machdep.c,v 1.6.10.5 2010/03/21 17:38:33 cliff Exp $");
+__KERNEL_RCSID(0, "machdep.c,v 1.6.10.5 2010/03/21 17:38:33 cliff Exp");
 
 #include "opt_ddb.h"
@@ -328,5 +328,5 @@
 	 * Also clears the I+D caches.
 	 */
-	mips_vector_init(NULL);
+	mips_vector_init(NULL, false);
 
 	/*
@@ -507,5 +507,5 @@
 
 	/* Take a snapshot before clobbering any registers. */
-	savectx(curlwp->l_addr);
+	savectx(lwp_getpcb(curlwp));
 
 	/* If "always halt" was specified as a boot flag, obey. */
Index: /trunk/src/sys/arch/evbmips/alchemy/machdep.c
===================================================================
--- /trunk/src/sys/arch/evbmips/alchemy/machdep.c	(revision 151)
+++ /trunk/src/sys/arch/evbmips/alchemy/machdep.c	(revision 152)
@@ -1,3 +1,3 @@
-/* $NetBSD: machdep.c,v 1.37.10.5 2010/03/21 17:38:33 cliff Exp $ */
+/* $NetBSD: machdep.c,v 1.37.10.6 2011/05/13 17:30:43 matt Exp $ */
 
 /*-
@@ -108,5 +108,5 @@
 
 #include <sys/cdefs.h>			/* RCS ID & Copyright macro defns */
-__KERNEL_RCSID(0, "$NetBSD: machdep.c,v 1.37.10.5 2010/03/21 17:38:33 cliff Exp $");
+__KERNEL_RCSID(0, "$NetBSD: machdep.c,v 1.37.10.6 2011/05/13 17:30:43 matt Exp $");
 
 #include "opt_ddb.h"
@@ -213,5 +213,5 @@
 	 * Also clears the I+D caches.
 	 */
-	mips_vector_init(NULL);
+	mips_vector_init(NULL, false);
 
 	/*
@@ -427,5 +427,5 @@
 
 	/* Take a snapshot before clobbering any registers. */
-	savectx(curlwp->l_addr);
+	savectx(lwp_getpcb(curlwp));
 
 	board = board_info();
Index: /trunk/src/sys/arch/evbmips/atheros/machdep.c
===================================================================
--- /trunk/src/sys/arch/evbmips/atheros/machdep.c	(revision 151)
+++ /trunk/src/sys/arch/evbmips/atheros/machdep.c	(revision 152)
@@ -1,3 +1,3 @@
-/* $NetBSD: machdep.c,v 1.13.10.6 2010/03/21 17:38:34 cliff Exp $ */
+/* $NetBSD: machdep.c,v 1.13.10.7 2011/05/13 17:30:43 matt Exp $ */
 
 /*
@@ -148,5 +148,5 @@
 
 #include <sys/cdefs.h>			/* RCS ID & Copyright macro defns */
-__KERNEL_RCSID(0, "$NetBSD: machdep.c,v 1.13.10.6 2010/03/21 17:38:34 cliff Exp $");
+__KERNEL_RCSID(0, "$NetBSD: machdep.c,v 1.13.10.7 2011/05/13 17:30:43 matt Exp $");
 
 #include "opt_ddb.h"
@@ -241,5 +241,5 @@
 	 * Also clears the I+D caches.
 	 */
-	mips_vector_init(NULL);
+	mips_vector_init(NULL, false);
 
 	/*
@@ -394,5 +394,5 @@
 
 	/* Take a snapshot before clobbering any registers. */
-	savectx(curlwp->l_addr);
+	savectx(lwp_getpcb(curlwp));
 
 	/* If "always halt" was specified as a boot flag, obey. */
Index: /trunk/src/sys/arch/evbmips/conf/ALCHEMY
===================================================================
--- /trunk/src/sys/arch/evbmips/conf/ALCHEMY	(revision 151)
+++ /trunk/src/sys/arch/evbmips/conf/ALCHEMY	(revision 152)
@@ -1,3 +1,3 @@
-#	$NetBSD: ALCHEMY,v 1.20.8.2 2010/01/29 00:16:57 matt Exp $
+#	ALCHEMY,v 1.20.8.2 2010/01/29 00:16:57 matt Exp
 #
 # Kernel config for the Alchemy Semiconductor (AMD) PB1000, PB1500,
@@ -6,5 +6,5 @@
 include 	"arch/evbmips/conf/std.alchemy"
 
-#ident 		"ALCHEMY-$Revision: 1.20.8.2 $"
+#ident 		"ALCHEMY-1.20.8.2"
 
 maxusers	32
@@ -49,5 +49,5 @@
 options 	DDB_HISTORY_SIZE=100 # enable history editing in DDB
 makeoptions 	DEBUG="-g"	# compile full symbol table
-options 	SYMTAB_SPACE=425000	# size for embedded symbol table
+options 	SYMTAB_SPACE=475000	# size for embedded symbol table
 
 # Compatibility options
Index: /trunk/src/sys/arch/evbmips/conf/INSTALL_MALTA
===================================================================
--- /trunk/src/sys/arch/evbmips/conf/INSTALL_MALTA	(revision 151)
+++ /trunk/src/sys/arch/evbmips/conf/INSTALL_MALTA	(revision 152)
@@ -1,7 +1,7 @@
-# $NetBSD: INSTALL_MALTA,v 1.1.2.1 2009/08/24 04:03:30 matt Exp $
+# $NetBSD: INSTALL_MALTA,v 1.1.2.2 2011/05/26 19:22:46 matt Exp $
 
 include		"arch/evbmips/conf/MALTA"
 
-#ident 		"INSTALL_MALTA-$Revision: 1.1.2.1 $"
+#ident 		"INSTALL_MALTA-$Revision: 1.1.2.2 $"
 
 # Enable the hooks used for initializing the root memory-disk.
@@ -13,2 +13,4 @@
 options 	MEMORY_DISK_SERVER=0		# no userspace memory disk
 options 	MEMORY_DISK_ROOT_SIZE=12288	# size of memory disk, in blocks
+
+makeoptions	NEED_MDSETIMAGE="yes"
Index: /trunk/src/sys/arch/evbmips/conf/INSTALL_MALTA32
===================================================================
--- /trunk/src/sys/arch/evbmips/conf/INSTALL_MALTA32	(revision 151)
+++ /trunk/src/sys/arch/evbmips/conf/INSTALL_MALTA32	(revision 152)
@@ -1,7 +1,7 @@
-# $NetBSD: INSTALL_MALTA32,v 1.1.2.1 2009/08/24 04:03:30 matt Exp $
+# $NetBSD: INSTALL_MALTA32,v 1.1.2.2 2011/05/26 19:22:47 matt Exp $
 
 include		"arch/evbmips/conf/MALTA32"
 
-#ident 		"INSTALL_MALTA32-$Revision: 1.1.2.1 $"
+#ident 		"INSTALL_MALTA32-$Revision: 1.1.2.2 $"
 
 # Enable the hooks used for initializing the root memory-disk.
@@ -13,2 +13,4 @@
 options 	MEMORY_DISK_SERVER=0		# no userspace memory disk
 options 	MEMORY_DISK_ROOT_SIZE=12288	# size of memory disk, in blocks
+
+makeoptions	NEED_MDSETIMAGE="yes"
Index: /trunk/src/sys/arch/evbmips/conf/INSTALL_MALTA64
===================================================================
--- /trunk/src/sys/arch/evbmips/conf/INSTALL_MALTA64	(revision 151)
+++ /trunk/src/sys/arch/evbmips/conf/INSTALL_MALTA64	(revision 152)
@@ -1,7 +1,7 @@
-# $NetBSD: INSTALL_MALTA64,v 1.1.2.1 2009/08/24 04:03:30 matt Exp $
+# $NetBSD: INSTALL_MALTA64,v 1.1.2.2 2011/05/26 19:22:47 matt Exp $
 
 include		"arch/evbmips/conf/MALTA64"
 
-#ident 		"INSTALL_MALTA64-$Revision: 1.1.2.1 $"
+#ident 		"INSTALL_MALTA64-$Revision: 1.1.2.2 $"
 
 # Enable the hooks used for initializing the root memory-disk.
@@ -13,2 +13,4 @@
 options 	MEMORY_DISK_SERVER=0		# no userspace memory disk
 options 	MEMORY_DISK_ROOT_SIZE=12288	# size of memory disk, in blocks
+
+makeoptions	NEED_MDSETIMAGE="yes"
Index: /trunk/src/sys/arch/evbmips/conf/MALTA
===================================================================
--- /trunk/src/sys/arch/evbmips/conf/MALTA	(revision 151)
+++ /trunk/src/sys/arch/evbmips/conf/MALTA	(revision 152)
@@ -1,3 +1,3 @@
-#	$NetBSD: MALTA,v 1.48.8.3 2010/01/29 00:16:57 matt Exp $
+#	MALTA,v 1.48.8.3 2010/01/29 00:16:57 matt Exp
 
 include 	"arch/evbmips/conf/std.malta"
@@ -5,5 +5,5 @@
 #options 	INCLUDE_CONFIG_FILE	# embed config file in kernel binary
 
-#ident 		"MALTA-$Revision: 1.48.8.3 $"
+#ident 		"MALTA-1.48.8.3"
 
 maxusers	32
@@ -40,5 +40,5 @@
 options 	DDB_HISTORY_SIZE=100 # enable history editing in DDB
 makeoptions 	DEBUG="-g"	# compile full symbol table
-options 	SYMTAB_SPACE=400000	# size for embedded symbol table
+options 	SYMTAB_SPACE=410000	# size for embedded symbol table
 
 # Compatibility options
Index: /trunk/src/sys/arch/evbmips/conf/MALTA32.MP
===================================================================
--- /trunk/src/sys/arch/evbmips/conf/MALTA32.MP	(revision 152)
+++ /trunk/src/sys/arch/evbmips/conf/MALTA32.MP	(revision 152)
@@ -0,0 +1,8 @@
+# $NetBSD: MALTA32.MP,v 1.1.2.1 2010/12/29 08:19:19 matt Exp $
+#
+include "arch/evbmips/conf/MALTA32"
+
+options 	MULTIPROCESSOR
+options 	LOCKDEBUG
+
+pseudo-device	lockstat
Index: /trunk/src/sys/arch/evbmips/conf/Makefile.evbmips.inc
===================================================================
--- /trunk/src/sys/arch/evbmips/conf/Makefile.evbmips.inc	(revision 151)
+++ /trunk/src/sys/arch/evbmips/conf/Makefile.evbmips.inc	(revision 152)
@@ -1,6 +1,39 @@
-#	$NetBSD: Makefile.evbmips.inc,v 1.2 2005/11/24 12:54:29 dbj Exp $
+#	Makefile.evbmips.inc,v 1.2 2005/11/24 12:54:29 dbj Exp
 
-SYSTEM_LD_TAIL_EXTRA=; \
+RAMDISKDIR!=	cd ${NETBSDSRCDIR}/distrib/${THISMIPS:T}/instkernel/ramdisk && ${PRINTOBJDIR}
+
+.if defined(NEED_MDSETIMAGE) && ${NEED_MDSETIMAGE} != no \
+    && exists(${RAMDISKDIR}/ramdisk.fs)
+SYSTEM_LD_TAIL_EXTRA+=; \
+	echo ${TOOL_MDSETIMAGE} -s $@ ${RAMDISKDIR}/ramdisk.fs; \
+	${TOOL_MDSETIMAGE} -s $@ ${RAMDISKDIR}/ramdisk.fs
+.endif
+
+.if defined(NEED_SREC) && ${NEED_SREC} != "no"
+SYSTEM_LD_TAIL_EXTRA+=; \
 	echo ${STRIP} -O srec -o $@.srec $@; \
 	${STRIP} -O srec -o $@.srec $@
 EXTRA_KERNELS+= ${KERNELS:@.KERNEL.@${.KERNEL.}.srec@}
+.endif
+
+.if defined(NEED_BINARY) && ${NEED_BINARY} != "no"
+SYSTEM_LD_TAIL_EXTRA+=; \
+	echo ${OBJCOPY} -S -O binary $@ $@.bin; \
+	${OBJCOPY} -S -O binary $@ $@.bin
+
+EXTRA_KERNELS+= ${KERNELS:@.KERNEL.@${.KERNEL.}.bin@}
+
+.if defined(NEED_UBOOTIMAGE) && ${NEED_UBOOTIMAGE} != "no"
+_OSRELEASE!=		${HOST_SH} $S/conf/osrelease.sh
+MKUBOOTIMAGEARGS=       -A mips -T kernel -C none
+MKUBOOTIMAGEARGS+=      -a ${TEXTADDR:C/....$/0000/} -e $(TEXTADDR)
+MKUBOOTIMAGEARGS+=      -n "NetBSD/$(MACHINE) ${_OSRELEASE} ($(KERNEL_BUILD:T))"
+
+SYSTEM_LD_TAIL_EXTRA+=; \
+	echo ${TOOL_MKUBOOTIMAGE} ${MKUBOOTIMAGEARGS} $@.bin $@.ub; \
+	${TOOL_MKUBOOTIMAGE} ${MKUBOOTIMAGEARGS} $@.bin $@.ub; \
+
+EXTRA_KERNELS+= ${KERNELS:@.KERNEL.@${.KERNEL.}.ub@}
+.endif
+.endif
+
Index: /trunk/src/sys/arch/evbmips/conf/RB153
===================================================================
--- /trunk/src/sys/arch/evbmips/conf/RB153	(revision 151)
+++ /trunk/src/sys/arch/evbmips/conf/RB153	(revision 152)
@@ -1,4 +1,4 @@
-#	$NetBSD: RB153,v 1.2.58.1 2010/01/29 00:16:58 matt Exp $
-#	$Id: RB153,v 1.2.58.1 2010/01/29 00:16:58 matt Exp $
+#	RB153,v 1.2.58.1 2010/01/29 00:16:58 matt Exp
+#	RB153,v 1.2.58.1 2010/01/29 00:16:58 matt Exp
 #
 # Example kernel config for the RouterBOARD 153.
@@ -6,5 +6,5 @@
 include 	"arch/evbmips/conf/std.adm5120"
 
-#ident 		"GENERIC-$Revision: 1.2.58.1 $"
+#ident 		"GENERIC-1.2.58.1"
 
 maxusers	32
@@ -36,5 +36,5 @@
 makeoptions 	DEBUG="-g"	# compile full symbol table
 makeoptions 	CPUFLAGS="-march=4kc"
-options 	SYMTAB_SPACE=380000	# size for embedded symbol table
+options 	SYMTAB_SPACE=410000	# size for embedded symbol table
 
 #options 	MEMORY_DISK_HOOKS
Index: /trunk/src/sys/arch/evbmips/conf/XLSATX
===================================================================
--- /trunk/src/sys/arch/evbmips/conf/XLSATX	(revision 151)
+++ /trunk/src/sys/arch/evbmips/conf/XLSATX	(revision 152)
@@ -1,7 +1,7 @@
-#	$NetBSD: XLSATX,v 1.1.2.9 2010/05/11 21:08:01 matt Exp $
+#	$NetBSD: XLSATX,v 1.1.2.14 2011/04/29 09:23:16 matt Exp $
 
 include 	"arch/evbmips/conf/std.rmixl"
 
-#ident 		"XLSATX-$Revision: 1.1.2.9 $"
+#ident 		"XLSATX-$Revision: 1.1.2.14 $"
 
 #options 	INCLUDE_CONFIG_FILE	# embed config file in kernel binary
@@ -12,5 +12,5 @@
 # MEMSIZE can be used to limit memory amount used
 #
-##options		MEMSIZE=0x10000000		# 256MB 
+#options 	MEMSIZE=0x10000000		# 256MB
 
 #
@@ -18,5 +18,5 @@
 #
 defparam opt_memsize.h MEMLIMIT
-##options	MEMLIMIT=0x10000000			# 256MB 
+#options 	MEMLIMIT=0x10000000		# 256MB
 
 options 	NOFPU		# No FPU
@@ -36,4 +36,5 @@
 options 	DEBUG		# extra kernel debugging support
 #options 	KMEMSTATS	# kernel memory statistics (vmstat -m)
+options 	MSGBUFSIZE=65536 # kernel dmesg buffer
 options 	USERCONF	# userconf(4) support
 #options 	SYSCTL_INCLUDE_DESCR	# Include sysctl descriptions in kernel
@@ -42,6 +43,6 @@
 makeoptions 	DEBUG="-g"	# compile full symbol table
 options 	SYMTAB_SPACE=500000	# size for embedded symbol table
-#options	DDB_COMMANDONENTER="trace;show registers"
-options		DB_MAX_LINE=-1
+#options 	DDB_COMMANDONENTER="trace;show registers"
+options 	DB_MAX_LINE=-1
 
 # Compatibility options
@@ -67,5 +68,5 @@
 #file-system 	EXT2FS		# second extended file system (linux)
 file-system	NFS		# Sun NFS-compatible filesystem client
-#file-system	KERNFS		# kernel data-structure filesystem
+file-system	KERNFS		# kernel data-structure filesystem
 #file-system	NULLFS		# NULL layered filesystem
 #file-system 	OVERLAY		# overlay file system
@@ -73,6 +74,6 @@
 #file-system	UMAPFS		# uid/gid remapping filesystem
 #file-system	LFS		# Log-based filesystem (still experimental)
-#file-system	PORTAL		# portal filesystem (still experimental)
-#file-system	PROCFS		# /proc
+#file-system	PUFFS		# Userspace file systems (e.g. ntfs-3g & sshfs)
+file-system	PROCFS		# /proc
 #file-system	CD9660		# ISO 9660 + Rock Ridge file system
 file-system	TMPFS		# Efficient memory file system
@@ -80,5 +81,5 @@
 #file-system	MSDOSFS		# MS-DOS FAT filesystem(s).
 #file-system 	CODA		# Coda File System; also needs vcoda (below)
-#file-system	PTYFS		# /dev/pts/N support
+file-system	PTYFS		# /dev/pts/N support
 
 # File system options
@@ -135,16 +136,18 @@
 config	netbsd-wm0	root on wm0 type nfs
 config	netbsd-msk0	root on msk0 type nfs
+config	netbsd-sd0a	root on sd0a type ffs
 
 
 mainbus0 	at root
-cpunode*	at mainbus? node ?
-cpucore*	at cpunode? core ?
+cpunode* 	at mainbus? node ?
+cpucore* 	at cpunode? core ?
 cpu*		at cpucore? thread ?
 obio0		at cpunode?
-com0		at obio0	addr 0x14000 mult 4 intr 9
-options		COM_REGMAP
-rmixl_pcix0	at obio0
+com0		at obio0	addr 0x14000 intr 9
+com1		at obio0	addr 0x15000 intr 10
+options 	COM_REGMAP
+rmixl_pcix0 	at obio0
 pci*		at rmixl_pcix0
-rmixl_pcie0	at obio0
+rmixl_pcie0 	at obio0
 pci*		at rmixl_pcie0
 ppb*		at pci?
@@ -157,9 +160,9 @@
 makphy*		at mii? phy ?			# Marvell 88E1000 PHYs
 ukphy*		at mii? phy ?			# unknown PHY
-rmixl_usbi0	at obio0	addr 0x25000 intr 31
+rmixl_usbi0 	at obio0	addr 0x25000 intr 31
 ohci0		at rmixl_usbi0	addr 0x24400 size 0x400 intr 0
 ohci1		at rmixl_usbi0	addr 0x24800 size 0x400 intr 1
 ehci0		at rmixl_usbi0	addr 0x24000 size 0x400 intr 2
-siisata*	at pci? dev ? function ?
+siisata* 	at pci? dev ? function ?
 atabus*		at ata?
 wd*		at atabus? drive ? flags 0x0000
@@ -172,5 +175,5 @@
 umass*		at uhub? port ? configuration ? interface ?
 wd*		at umass?
-scsibus*	at umass? channel ?
+scsibus* 	at umass? channel ?
 sd*		at scsibus? target ? lun ?
 
@@ -201,4 +204,5 @@
 #pseudo-device	vlan				# IEEE 802.1q encapsulation
 #pseudo-device	bridge				# simple inter-network bridging
+pseudo-device	kttcp				# kernel ttcp
 
 # Miscellaneous pseudo-devices
Index: /trunk/src/sys/arch/evbmips/conf/XLSATX32
===================================================================
--- /trunk/src/sys/arch/evbmips/conf/XLSATX32	(revision 151)
+++ /trunk/src/sys/arch/evbmips/conf/XLSATX32	(revision 152)
@@ -1,8 +1,10 @@
-# $NetBSD: XLSATX32,v 1.1.2.1 2009/12/14 07:24:33 cliff Exp $
+# $NetBSD: XLSATX32,v 1.1.2.2 2011/04/29 09:27:12 matt Exp $
 #
+
+#ident  	"XLSATX32-$Revision: 1.1.2.2 $"
 
 include "arch/evbmips/conf/XLSATX"
 
-#ident 		"XLSATX32-$Revision: 1.1.2.1 $"
+options 	MEMLIMIT=0x20000000			# 512MB 
 
 makeoptions	LP64="no"
Index: /trunk/src/sys/arch/evbmips/conf/std.rmixl
===================================================================
--- /trunk/src/sys/arch/evbmips/conf/std.rmixl	(revision 151)
+++ /trunk/src/sys/arch/evbmips/conf/std.rmixl	(revision 152)
@@ -1,17 +1,18 @@
-# $NetBSD: std.rmixl,v 1.1.2.4 2010/03/29 23:31:16 cliff Exp $
+# std.rmixl,v 1.1.2.4 2010/03/29 23:31:16 cliff Exp
 
 machine evbmips mips
 include		"conf/std"	# MI standard options
 
-options MIPS3_ENABLE_CLOCK_INTR
+options 	MIPS3_ENABLE_CLOCK_INTR
 
 # Platform support
-options		MIPS64
+#options 	MIPS64
 options		MIPS64_XLR
 options		MIPS64_XLS
+options		MIPS64_RMIXL
 
 
-options	EXEC_ELF32	# exec ELF32 binaries
-options	EXEC_SCRIPT	# exec #! scripts
+options 	EXEC_ELF32	# exec ELF32 binaries
+options 	EXEC_SCRIPT	# exec #! scripts
 
 makeoptions	CPUFLAGS+="-mips64"
Index: /trunk/src/sys/arch/evbmips/malta/machdep.c
===================================================================
--- /trunk/src/sys/arch/evbmips/malta/machdep.c	(revision 151)
+++ /trunk/src/sys/arch/evbmips/malta/machdep.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: machdep.c,v 1.28.10.8 2010/03/21 17:38:34 cliff Exp $	*/
+/*	$NetBSD: machdep.c,v 1.28.10.9 2011/04/29 08:26:18 matt Exp $	*/
 
 /*
@@ -113,5 +113,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: machdep.c,v 1.28.10.8 2010/03/21 17:38:34 cliff Exp $");
+__KERNEL_RCSID(0, "$NetBSD: machdep.c,v 1.28.10.9 2011/04/29 08:26:18 matt Exp $");
 
 #include "opt_ddb.h"
@@ -129,4 +129,5 @@
 #include <sys/termios.h>
 #include <sys/ksyms.h>
+#include <sys/lwp.h>
 
 #include <uvm/uvm_extern.h>
@@ -182,10 +183,4 @@
 void	configure(void);
 void	mach_init(int, char **, yamon_env_var *, u_long);
-
-/*
- * safepri is a safe priority for sleep to set for a spin-wait during
- * autoconfiguration or after a panic.  Used as an argument to splx().
- */
-int	safepri = MIPS1_PSL_LOWIPL;
 
 /*
@@ -229,5 +224,5 @@
 	 * Also clears the I+D caches.
 	 */
-	mips_vector_init(NULL);
+	mips_vector_init(NULL, false);
 
 	/* set the VM page size */
@@ -377,5 +372,5 @@
 
 	/* Take a snapshot before clobbering any registers. */
-	savectx(curlwp->l_addr);
+	savectx(lwp_getpcb(curlwp));
 
 	if (cold) {
Index: /trunk/src/sys/arch/evbmips/rmixl/autoconf.c
===================================================================
--- /trunk/src/sys/arch/evbmips/rmixl/autoconf.c	(revision 151)
+++ /trunk/src/sys/arch/evbmips/rmixl/autoconf.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: autoconf.c,v 1.1.2.2 2010/01/14 00:40:35 matt Exp $	*/
+/*	$NetBSD: autoconf.c,v 1.1.2.4 2011/04/29 08:26:18 matt Exp $	*/
 
 /*
@@ -37,5 +37,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: autoconf.c,v 1.1.2.2 2010/01/14 00:40:35 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: autoconf.c,v 1.1.2.4 2011/04/29 08:26:18 matt Exp $");
 
 #include <sys/param.h>
@@ -84,15 +84,21 @@
 findroot(void)
 {
-	device_t dv;
-
 	if (booted_device)
 		return;
 
-	if ((booted_device == NULL) && netboot == 0)
-		for (dv = TAILQ_FIRST(&alldevs); dv != NULL;
-		     dv = TAILQ_NEXT(dv, dv_list))
-			if (device_class(dv) == DV_DISK &&
-			    device_is_a(dv, "wd"))
-				    booted_device = dv;
+	if ((booted_device == NULL) && netboot == 0) {
+		device_t dv;
+		deviter_t di;
+
+		for (dv = deviter_first(&di, DEVITER_F_ROOT_FIRST); dv != NULL;
+		    dv = deviter_next(&di)) {
+			if (device_class(dv) == DV_DISK
+			    && (device_is_a(dv, "wd")
+				|| device_is_a(dv, "sd")
+				|| device_is_a(dv, "ld")))
+				booted_device = dv;
+		}
+		deviter_release(&di);
+	}
 
 	/*
@@ -100,13 +106,10 @@
 	 */
 	booted_partition = 0;
-
-	return;
 }
 
 void
-device_register(dev, aux)
-	device_t dev;
-	void *aux;
+device_register(device_t dev, void *aux)
 {
+
 	if ((booted_device == NULL) && (netboot == 1))
 		if (device_class(dev) == DV_IFNET)
